clear all
clc


 %Importing and purging baseline data
    datapath={'D:\2 reserch论文\RCEP\3 data and counterfactual\files\data_file'}; %complete as necessary
    global BETA THETA DELTA MU PHI ALPHAs SIGMA%defined here
    BETA=readmatrix([datapath{1} '\beta_RCEP.xlsx'],'Range','B2:J62');
    DELTA=readmatrix([datapath{1} '\delta_RCEP.xlsx'],'Range','C2:K3722');
    THETA=readmatrix([datapath{1} '\theta_phi_mu1.xlsx'],'Range','C2:C62');
    PHI=zeros(61,1);
    MU=readmatrix([datapath{1} '\theta_phi_mu1.xlsx'],'Range','E2:E62');
    SIGMA=1+THETA;
    TRADE=readmatrix([datapath{1} '\trade_RCEP.xlsx'],'Range','C2:K550'); 
    for n=1:9
    for j=1:549
        if TRADE(j,n)==0
            TRADE(j,n)=1E-09;
        end
    end
    end
    TARIFF=readmatrix([datapath{1} '\tariff_RCEP.xlsx'],'Range','C2:K550');
    save('RAWDATA_RCEP','BETA','DELTA','THETA','PHI','MU','SIGMA','TRADE','TARIFF') %this is the raw data
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','SIGMA','TRADE','TARIFF')
    mycalculations_RCEP
    SIGMA_N_S_S=permute(repmat(SIGMA_N_S,[1 1 S]),[1 3 2]);
    TEMP=sum((1-BETA_N_S_S).*DELTA_N_S_S.*(SIGMA_N_S_S-1)./SIGMA_N_S_S.*permute(repmat(Y_ns,[1 1 S]),[1 3 2]),3);
    ALPHAs=(reshape(sum(EXPENDITURE_N_N_S,1),[N S])-TEMP)./repmat(I,[1 S]);
for j=1:S
    for n=1:N
        if ALPHAs(n,j)<0
            ALPHAs(n,j)=1E-07;
        end
    end
end
    ALPHAs=ALPHAs./repmat(sum(ALPHAs,2),[1 S]);
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','ALPHAs','SIGMA','TRADE','TARIFF')
    [ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT]=mycounterfactuals(TARIFFs,zeros(N,N,S),zeros(N,1),ones(N,S));
    TRADE=reshape(permute(TRADECs,[1 3 2]),[N*S,N,1]);
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','ALPHAs','SIGMA','TRADE','TARIFF') %remove Deficit
    mycalculations_RCEP 
    
    [ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT]=mycounterfactuals(TARIFFs,zeros(N,N,S),zeros(N,1),ones(N,S));
    TRADE=reshape(permute(TRADECs,[1 3 2]),[N*S,N,1]);
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','ALPHAs','SIGMA','TRADE','TARIFF') %remove Deficit
    mycalculations_RCEP %re-equilibrium
      
    tariff_RCEP=readmatrix([datapath{1} '\RCEP_timeline.xlsx'],'Range','D2:W4942');
    temp=reshape(tariff_RCEP,[N,N,S,20 ]);
    tariff_RCEP=permute(temp,[2 1 3 4]);    
   
%% RCEP welfare effects
results=zeros(9,5);
TARIFFCs=tariff_RCEP(:,:,:,20);
ETARIFFCs=zeros(N,N,S);
[ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT AGGREGATEPRICEINDEXHAT PMjHAT]=mycounterfactuals(TARIFFCs,ETARIFFCs,D,ones(N,S));
[TOT profit Leffect R TOT_sector profit_sector Leffect_sector R_sector]=welfaredecomposition(TRADECs,TARIFFCs,ETARIFFCs,LABORHAT,PRICEHAT,AGGREGATEPRICEINDEXHAT,PMjHAT,WAGEHAT, EXPENDITUREHAT);
for i=1:9
realwage=WAGEHAT(i)./AGGREGATEPRICEINDEXHAT(i);
temp=100*(TOT(i))+100*(profit(i))+100*(Leffect(i))+100*(R(i));
results(i,:)=[temp,100*(TOT(i)),100*(profit(i)),100*(R(i)),100*(Leffect(i))];
end
Table6=[results(3,:);results(5,:);results(6,:);results(1,:);results(2,:);results(7,:);results(4,:);results(9,:);results(8,:)];