%--------------------------------------------------------------
%This function solves for the effects of counterfactual tariffs
%--------------------------------------------------------------
function [ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT AGGREGATEPRICEINDEXHAT PMjHAT]=mycounterfactuals(TARIFFCs,ETARIFFCs,DC,P_weight)
%Defining global variables
global N S%Defined in mycalculations


vfactor  = 0.1;    %adjustment factor
tol      = 1E-07;   %tolerance
maxit    = 1E+10;   %max number of 

%Solving for equilibrium
[WAGEHAT LABORHAT PRICEHAT EXPENDITUREHAT ] = equilibrium_C(TARIFFCs,ETARIFFCs,DC,maxit,tol,vfactor);  %this function solves for the equilibrium

%Retrieving results and computing WELFAREHAT
[EQUILIBRIUMCONDITION NUMERAIRECONDITION  AGGREGATEPRICEINDEXHAT TRADECs IHAT PMjHAT]=myconditions(WAGEHAT,LABORHAT,PRICEHAT,EXPENDITUREHAT,TARIFFCs,ETARIFFCs,DC);
WELFAREHAT=IHAT./AGGREGATEPRICEINDEXHAT;
end

%This is checked and correct