clear all
clc


 %Importing and purging baseline data
    datapath={'D:\2 reserch论文\RCEP\3 data and counterfactual\files\data_file'}; %complete as necessary
    global BETA THETA DELTA MU PHI ALPHAs SIGMA%defined here
    BETA=readmatrix([datapath{1} '\beta_RCEP.xlsx'],'Range','B2:J62');
    DELTA=readmatrix([datapath{1} '\delta_RCEP.xlsx'],'Range','C2:K3722');
    THETA=readmatrix([datapath{1} '\theta_phi_mu1.xlsx'],'Range','C2:C62');
    PHI=readmatrix([datapath{1} '\theta_phi_mu1.xlsx'],'Range','D2:D62');
    MU=readmatrix([datapath{1} '\theta_phi_mu1.xlsx'],'Range','E2:E62');
    SIGMA=1+THETA;
    TRADE=readmatrix([datapath{1} '\trade_RCEP.xlsx'],'Range','C2:K550'); 
    for n=1:9
    for j=1:549
        if TRADE(j,n)==0
            TRADE(j,n)=1E-09;
        end
    end
    end
    TARIFF=readmatrix([datapath{1} '\tariff_RCEP.xlsx'],'Range','C2:K550');
    save('RAWDATA_RCEP','BETA','DELTA','THETA','PHI','MU','SIGMA','TRADE','TARIFF') %this is the raw data
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','SIGMA','TRADE','TARIFF')
    mycalculations_RCEP
    SIGMA_N_S_S=permute(repmat(SIGMA_N_S,[1 1 S]),[1 3 2]);
    TEMP=sum((1-BETA_N_S_S).*DELTA_N_S_S.*(SIGMA_N_S_S-1)./SIGMA_N_S_S.*permute(repmat(Y_ns,[1 1 S]),[1 3 2]),3);
    ALPHAs=(reshape(sum(EXPENDITURE_N_N_S,1),[N S])-TEMP)./repmat(I,[1 S]);
for j=1:S
    for n=1:N
        if ALPHAs(n,j)<0
            ALPHAs(n,j)=1E-07;
        end
    end
end
    ALPHAs=ALPHAs./repmat(sum(ALPHAs,2),[1 S]);
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','ALPHAs','SIGMA','TRADE','TARIFF')
    [ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT]=mycounterfactuals(TARIFFs,zeros(N,N,S),zeros(N,1),ones(N,S));
    TRADE=reshape(permute(TRADECs,[1 3 2]),[N*S,N,1]);
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','ALPHAs','SIGMA','TRADE','TARIFF') %remove Deficit
     
    mycalculations_RCEP %re-equilibrium
     Dmax=1 ; 
      while (Dmax >1E-03) 
    [ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT]=mycounterfactuals(TARIFFs,zeros(N,N,S),zeros(N,1),ones(N,S));
    TRADE=reshape(permute(TRADECs,[1 3 2]),[N*S,N,1]);
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','ALPHAs','SIGMA','TRADE','TARIFF') 
     mycalculations_RCEP
    Dmax=max(D);
      end
      
    tariff_RCEP=readmatrix([datapath{1} '\RCEP_timeline.xlsx'],'Range','D2:W4942');
    temp=reshape(tariff_RCEP,[N,N,S,20 ]);
    tariff_RCEP=permute(temp,[2 1 3 4]);    
   



%% RCEP+subsidy
%baseline
results3=zeros(9,1);
TARIFFCs=tariff_RCEP(:,:,:,15);
ETARIFFCs=zeros(N,N,S);
[ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT AGGREGATEPRICEINDEXHAT PMjHAT]=mycounterfactuals(TARIFFCs,ETARIFFCs,D,ones(N,S));
[TOT profit Leffect R TOT_sector profit_sector Leffect_sector R_sector]=welfaredecomposition(TRADECs,TARIFFCs,ETARIFFCs,LABORHAT,PRICEHAT,AGGREGATEPRICEINDEXHAT,PMjHAT,WAGEHAT, EXPENDITUREHAT);
for i=1:9
realwage=WAGEHAT(i)./AGGREGATEPRICEINDEXHAT(i);
temp=100*(TOT(i))+100*(profit(i))+100*(Leffect(i))+100*(R(i));
results3(i,:)=temp;
end
Table7_1=results3;
t1=TRADEs;
t2=TRADECs;
for i=1:9
    t1(i,i,:)=0;
    t2(i,i,:)=0;
end
semiconductor=sum(t2(3,:,13),2)./sum(t1(3,:,13),2);


%only china
results3=zeros(9,6);
TARIFFCs=tariff_RCEP(:,:,:,15);
ETARIFFCs=zeros(N,N,S);
for i=1:9
    for s=[13 14 21 30 ]
ETARIFFCs(3,i,s)=-0.05;
    end
end
[ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT AGGREGATEPRICEINDEXHAT PMjHAT]=mycounterfactuals(TARIFFCs,ETARIFFCs,D,ones(N,S));
[TOT profit Leffect R TOT_sector profit_sector Leffect_sector R_sector]=welfaredecomposition(TRADECs,TARIFFCs,ETARIFFCs,LABORHAT,PRICEHAT,AGGREGATEPRICEINDEXHAT,PMjHAT,WAGEHAT, EXPENDITUREHAT);
for i=1:9
realwage=WAGEHAT(i)./AGGREGATEPRICEINDEXHAT(i);
temp=100*(TOT(i))+100*(profit(i))+100*(Leffect(i))+100*(R(i));
results3(i,:)=[Table7_1(i),temp,100*(TOT(i)),100*(profit(i)),100*(Leffect(i)),100*(R(i))];
end
Table7=[results3(3,:);results3(5,:);results3(6,:);results3(1,:);results3(2,:);results3(7,:);results3(4,:);results3(9,:);results3(8,:)];
welfare_sector=TOT_sector+ profit_sector +Leffect_sector +R_sector;
[w_sector T_sector P_sector r_sector L_sector ]=sector(TRADEs, welfare_sector, TOT_sector,  profit_sector,  Leffect_sector, R_sector);
CHN_sector=[(w_sector(3,:))'*100,(T_sector(3,:))'*100,(P_sector(3,:))'*100,(r_sector(3,:))'*100,(L_sector(3,:))'*100];
t1=TRADEs;
t2=TRADECs;
for i=1:9
    t1(i,i,:)=0;
    t2(i,i,:)=0;
end
semiconductor=sum(t2(3,:,13),2)./sum(t1(3,:,13),2);




%all countries with uniform subsidy
results3=zeros(9,6);
TARIFFCs=tariff_RCEP(:,:,:,15);
ETARIFFCs=zeros(N,N,S);
for i=1:9
    for j=1:9
    for s=[13 14 21 30]
ETARIFFCs(i,j,s)=-0.05;
    end
    end
end
[ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT AGGREGATEPRICEINDEXHAT PMjHAT]=mycounterfactuals(TARIFFCs,ETARIFFCs,D,ones(N,S));
[TOT profit Leffect R TOT_sector profit_sector Leffect_sector R_sector]=welfaredecomposition(TRADECs,TARIFFCs,ETARIFFCs,LABORHAT,PRICEHAT,AGGREGATEPRICEINDEXHAT,PMjHAT,WAGEHAT, EXPENDITUREHAT);
for i=1:9
realwage=WAGEHAT(i)./AGGREGATEPRICEINDEXHAT(i);
temp=100*(TOT(i))+100*(profit(i))+100*(Leffect(i))+100*(R(i));
results3(i,:)=[Table7_1(i),temp,100*(TOT(i)),100*(profit(i)),100*(Leffect(i)),100*(R(i))];
end
Table8=[results3(3,:);results3(5,:);results3(6,:);results3(1,:);results3(2,:);results3(7,:);results3(4,:);results3(9,:);results3(8,:)];
%% subsidy vs tariffs

appendix=zeros(6,5);
TARIFFCs=TARIFFs;
for i=1:9
    for s=[13 14 21 30 ]
TARIFFCs(i,3,s)=TARIFFCs(i,3,s)+0.05;
    end
end
TARIFFCs(3,3,:)=TARIFFs(3,3,:);
ETARIFFCs=zeros(N,N,S);
[ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT AGGREGATEPRICEINDEXHAT PMjHAT]=mycounterfactuals(TARIFFCs,ETARIFFCs,D,ones(N,S));
[TOT profit Leffect R TOT_sector profit_sector Leffect_sector R_sector]=welfaredecomposition(TRADECs,TARIFFCs,ETARIFFCs,LABORHAT,PRICEHAT,AGGREGATEPRICEINDEXHAT,PMjHAT,WAGEHAT, EXPENDITUREHAT);
temp=TOT +profit+ Leffect+ R;
appendix(1,:)=[100*temp(3),100*(TOT(3)),100*(profit(3)),100*(Leffect(3)),100*(R(3))];
temp=sum(TOT_sector(3,[13 14 21 30 ]),2)+sum(profit_sector(3,[13 14 21 30 ]),2)+sum(Leffect_sector(3,[13 14 21 30 ]),2)+sum(R_sector(3,[13 14 21 30 ]),2);
appendix(2,:)=[100*temp,100*sum(TOT_sector(3,[13 14 21 30 ]),2),100*sum(profit_sector(3,[13 14 21 30 ]),2),100*sum(Leffect_sector(3,[13 14 21 30 ]),2),100*sum(R_sector(3,[13 14 21 30 ]),2)];
appendix(3,:)=appendix(1,:)-appendix(2,:);


TARIFFCs=TARIFFs;
ETARIFFCs=zeros(N,N,S);
for i=1:9
    for s=[13 14 21 30 ]
ETARIFFCs(3,i,s)=-0.05;
    end
end
[ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT AGGREGATEPRICEINDEXHAT PMjHAT]=mycounterfactuals(TARIFFCs,ETARIFFCs,D,ones(N,S));
[TOT profit Leffect R TOT_sector profit_sector Leffect_sector R_sector]=welfaredecomposition(TRADECs,TARIFFCs,ETARIFFCs,LABORHAT,PRICEHAT,AGGREGATEPRICEINDEXHAT,PMjHAT,WAGEHAT, EXPENDITUREHAT);
temp=TOT +profit+ Leffect+ R;
appendix(4,:)=[100*temp(3),100*(TOT(3)),100*(profit(3)),100*(Leffect(3)),100*(R(3))];
temp=sum(TOT_sector(3,[13 14 21 30 ]),2)+sum(profit_sector(3,[13 14 21 30 ]),2)+sum(Leffect_sector(3,[13 14 21 30 ]),2)+sum(R_sector(3,[13 14 21 30 ]),2);
appendix(5,:)=[100*temp,100*sum(TOT_sector(3,[13 14 21 30 ]),2),100*sum(profit_sector(3,[13 14 21 30 ]),2),100*sum(Leffect_sector(3,[13 14 21 30 ]),2),100*sum(R_sector(3,[13 14 21 30 ]),2)];
appendix(6,:)=appendix(4,:)-appendix(5,:);