%Defining global variables
global  BETA THETA DELTA SIGMA_N_S MU PHI TRADEs D Y_ns DELTA_N_S_S BETA_N_S_S BETA_N_S I LABORINCOME_share EXPENDITURE_N_N_S MEANTARIFF WEIGHTs EXPENDITURE_1_N_S TAUTRADEs TARIFFREVENUE Ds Lambda_N_N_S TARIFFs N S   SIGMA_1_1_S SIGMA_N_1_S SIGMA_N_N_S PHIs_1_1_S PHIs_N_1_S PHIs_N_N_S  MUs_1_1_S MUs_N_1_S MUs_N_N_S BETAs_1_N_S BETAs_N_N_S EXPENDITURE  LABORINCOME_N_S LABORINCOME %Defined here
%Loading data
load DATA_RCEP
%Performing calculations
N=size(TRADE,2);
S=size(TRADE,1)./N;
TEMP=reshape(TRADE',[N N S]);
TRADEs=permute(TEMP,[2 1 3]);
TEMP=reshape(TARIFF',[N N S]);
TARIFFs=permute(TEMP,[2 1 3]);
WEIGHTs=TRADEs.*(1-repmat(eye(N,N),[1 1 S]))./repmat(sum(TRADEs.*(1-repmat(eye(N,N),[1 1 S])),1),[N 1 1]);
MEANTARIFF=permute(sum(WEIGHTs.*TARIFFs),[3 2 1]);
SIGMA_1_1_S=reshape(SIGMA,[1 1 S]);
SIGMA_N_1_S=repmat(SIGMA_1_1_S,[N 1 1]);
SIGMA_N_N_S=repmat(SIGMA_N_1_S,[1 N 1]);
PHIs_1_1_S=reshape(PHI,[1 1 S]);
PHIs_N_1_S=repmat(PHIs_1_1_S,[N 1 1]);
PHIs_N_N_S=repmat(PHIs_N_1_S,[1 N 1]);
MUs_1_1_S=reshape(MU,[1 1 S]);
MUs_N_1_S=repmat(MUs_1_1_S,[N 1 1]);
MUs_N_N_S=repmat(MUs_N_1_S,[1 N 1]);
BETAs_1_N_S=reshape(BETA',[1 N S]);
BETAs_N_N_S=repmat(BETAs_1_N_S,[N 1 1]);
TAUTRADEs=(1+TARIFFs).*TRADEs;
Ds=reshape(permute(sum(TRADEs,1),[2 1 3])-sum(TRADEs,2),[N S]);
D=sum(Ds,2);
Y_ns=reshape(sum(TRADEs,2),[N S]);
DELTA_N_S_S=permute(reshape(DELTA,[S S N]),[3 1 2]);
BETA_N_S=BETA';
BETA_N_S_S=permute(repmat(BETA_N_S,[1 1 S]),[1 3 2]);
SIGMA_N_S=permute(repmat(SIGMA,[1 N]),[2 1]);
LABORINCOME=sum(BETA_N_S.*Y_ns.*(SIGMA_N_S-1)./SIGMA_N_S,2);
LABORINCOME_N_S=BETA_N_S.*Y_ns.*(SIGMA_N_S-1)./SIGMA_N_S;
LABORINCOME_share=LABORINCOME_N_S./repmat(LABORINCOME,[1 S]);
TARIFFREVENUE=sum(TARIFF.*TRADE,1)';
profit=sum(1./SIGMA_N_S.*Y_ns,2);
I=LABORINCOME+TARIFFREVENUE+D+profit;
EXPENDITURE=sum(TRADE.*(1+TARIFF),1)';
EXPENDITURE_N_N_S=TRADEs.*(1+TARIFFs);
EXPENDITURE_1_N_S=repmat(sum(TRADEs.*(1+TARIFFs),1),[N 1 1]);
Lambda_N_N_S=EXPENDITURE_N_N_S./EXPENDITURE_1_N_S;